/*
    Definitionen zur Definition von Druckmodi ;-)

    Version 1.0
    Copyright (c) Markus Kohm, 1995

    Diese Datei wird fr nadel.c bentigt und mu von der
    Konfigurationsdatei eingebunden werden (siehe
*/

#ifndef PRT_BASE_H
#define PRT_BASE_H

#ifndef NULL
# define  NULL  ((void *)0)
#endif

typedef enum { false = 0, true } boolean;

typedef struct {
  int         p_dpi;              /* Auflsung */
  int         p_mode;             /*  0,1 = normal */
                                  /*  2 = halbe Auflsung emulieren */
                                  /*  3 = drittel Auflsung emulieren */
                                  /*  4 = viertel Auflsung emulieren */
                                  /* -1 = Halbpunktmodus */
                                  /* -2 = emulierter Halbpunktmodus */
#define EMUNORMAL     1
#define EMUHALF       2
#define EMUTRIPLE     3
#define EMUQUAD       4
#define EMUMAX  EMUQUAD
#define HALFPOINT    -1
#define EMUHALFPOINT -2
                                  /* Nicht bedruckbare Rnder (in Pixel): */
  int         p_top,              /*  oben */
              p_bottom;           /*  unten */

  /* Diverse Initialisierungsstrings */
  const char  *p_initplus;        /* zustzliche Initialisierung */
  const char  *p_resetplus;       /* zustzliches Rcksetzen */
  const char  *p_vskip;           /* Vorschub um <n> Pixelzeilen */
} PRTVMODE;

extern PRTVMODE PRTvmode[];
#define PRTvmodes (sizeof(PRTvmode) / sizeof(PRTVMODE))

typedef struct {
  int         p_dpi;              /* Auflsung */
  int         p_mode;             /*  0 = normal */
                                  /* -1 = In zwei Durchgngen jeden */
                                  /*      zweiten Punkt setzen */
#define NEEDLESPLIT -1
                                  /*  n = n-mal den gleichen Punkt */
                                  /*      hintereinander setzen */
  int         p_left,             /* links */
              p_right;            /* rechts */

  /* Diverse Initialisierungsstrings */
  const char  *p_initplus;        /* zustzliche Initialisierung */
  const char  *p_resetplus;       /* zustzliches Rcksetzen */
  int         p_relposmin;        /* Mindestpixelzahl fr Verwendung */
                                  /* einer relativen Positionierung */
  int         p_relposfac;        /* damit wird die Pixelzahl multpliziert */
  int         p_relposdiv;        /* dadurch wird die Pixelzahl dividiert */
  const char  *p_relpos;          /* relative Punktpositionierung */
  const char  *p_cr;              /* Wagenrcklauf */
  int         p_bppl;             /* Bytes je Druckerzeile */
  const char  *p_graphic;         /* Graphik-Modus */
} PRTHMODE;

extern PRTHMODE PRThmode[];
#define PRThmodes (sizeof(PRThmode) / sizeof(PRTHMODE))

typedef struct {
                                  /* Minimale, tatschliche und */
                                  /* Maximale Seitengre in */
                                  /* 1/1000 inch */
  long        p_minwidth,         /*  minimale Breite */
              p_width,            /*  tatschliche Breite */
              p_maxwidth,         /*  maximale Breite */
              p_minheight,        /*  minimale Hhe */
              p_height,           /*  tatschliche Hhe */
              p_maxheight;        /*  maximale Hhe */
  boolean     p_landscape;        /* Landscape-Modus verwenden! */
} PAGESIZE;

extern PAGESIZE PAGEsize[];
#define PAGEsizes (sizeof(PAGEsize) / sizeof(PAGESIZE))

#define MAXSIZE (0x7FFFFFFFL)

#endif  /* PRT_BASE_H */